from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, File, Boolean

Fermi_Ropebwt_V0_1_0 = CommandToolBuilder(tool="fermi_ropebwt", base_command=["fermi", "ropebwt"], inputs=[ToolInput(tag="in_algorithm_bpr_bcr", input_type=String(optional=True), prefix="-a", doc=InputDocumentation(doc="algorithm: bpr or bcr [bpr]")), ToolInput(tag="in_max_number_runs", input_type=Int(optional=True), prefix="-r", doc=InputDocumentation(doc="max number of runs in leaves (bpr only) [512]")), ToolInput(tag="in_max_number_children", input_type=Int(optional=True), prefix="-n", doc=InputDocumentation(doc="max number children per internal node (bpr only) [64]")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="output file [stdout]")), ToolInput(tag="in_temporary_sequence_file", input_type=File(optional=True), prefix="-f", doc=InputDocumentation(doc="temporary sequence file name (bcr only) [null]")), ToolInput(tag="in_verbose_level_bcr", input_type=Int(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose level (bcr only) [2]")), ToolInput(tag="in_binary_output_runs", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="binary output (5+3 runs starting after 4 bytes)")), ToolInput(tag="in_enable_threading_bcr", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="enable threading (bcr only)")), ToolInput(tag="in_skip_forward_strand", input_type=Boolean(optional=True), prefix="-F", doc=InputDocumentation(doc="skip forward strand")), ToolInput(tag="in_skip_reverse_strand", input_type=Boolean(optional=True), prefix="-R", doc=InputDocumentation(doc="skip reverse strand")), ToolInput(tag="in_cut_ambiguous_bases", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="cut at ambiguous bases")), ToolInput(tag="in_suppress_end_trimming", input_type=Boolean(optional=True), prefix="-O", doc=InputDocumentation(doc="suppress end trimming when forward==reverse")), ToolInput(tag="in_print_tree_stdout", input_type=Boolean(optional=True), prefix="-T", doc=InputDocumentation(doc="print the tree stdout (bpr only)")), ToolInput(tag="in_rope_bwt", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_dot_fq_do_tgz", input_type=String(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="output file [stdout]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Fermi_Ropebwt_V0_1_0().translate("wdl", allow_empty_container=True)

